SystemOrganization addCategory: #KeyChain!
SystemOrganization addCategory: #'KeyChain-UI'!

!PluggableTextFieldMorph methodsFor: '*keychain' stamp: 'EstebanLorenzano 12/6/2012 13:40'!
beDecrypted

	self textMorph font: TextStyle defaultFont.
	self updateTextMorph! !

!PluggableTextFieldMorph methodsFor: '*keychain' stamp: 'EstebanLorenzano 12/6/2012 13:41'!
beEncrypted

	self textMorph font: (StrikeFont passwordFontSize: self theme textFont pointSize).
	self updateTextMorph! !

!PluggableTextFieldMorph methodsFor: '*keychain' stamp: 'BenjaminVanRyseghem 10/25/2012 14:23'!
encrypted: aBoolean

	aBoolean
		ifTrue: [ self beEncrypted ]
		ifFalse: [ self beDecrypted ]! !

!PluggableTextFieldMorph methodsFor: '*keychain' stamp: 'BenjaminVanRyseghem 10/25/2012 14:22'!
updateTextMorph
	| text |
	
	text := textMorph
			ifNil: [ '' ]
			ifNotNil: [:t | 
				t delete.
				t contents ].	
	textMorph := nil.
	self setTextBasic: text ! !

!MCHttpRepository methodsFor: '*keychain' stamp: 'BenjaminVanRyseghem 10/25/2012 14:53'!
keyChainGroupSelector

	^ #monticelloDefault! !

TextEntryDialogWindow subclass: #PasswordInitializationDialogWindow
	instanceVariableNames: 'confirmationTextEditorMorph confirmationTextMorph showPassword container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KeyChain-UI'!

!PasswordInitializationDialogWindow commentStamp: '<historical>' prior: 0!
A PasswordInitializationDialogWindow is a dialog window asking twice for the same pssword to confirm it.

Used to set a password and ensure the entered value!

!PasswordInitializationDialogWindow methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/9/2012 23:30'!
autoAccept

	^false! !

!PasswordInitializationDialogWindow methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/10/2012 23:45'!
beDecrypted

	textEditorMorph font: self theme textFont.
	confirmationTextEditorMorph font: self theme textFont.! !

!PasswordInitializationDialogWindow methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/10/2012 23:45'!
beEncrypted

	textEditorMorph font: (StrikeFont passwordFontSize: self theme textFont pointSize).
	confirmationTextEditorMorph font: (StrikeFont passwordFontSize: self theme textFont pointSize)! !

!PasswordInitializationDialogWindow methodsFor: 'creation' stamp: 'BenjaminVanRyseghem 5/11/2012 15:58'!
buildInvalidPasswordLabel

	container := PanelMorph new
					color: Color transparent;
					changeProportionalLayout;
					height: 25;
					vResizing: #rigid;
					hResizing: #spaceFill;
					yourself.
					
	^ container! !

!PasswordInitializationDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/7/2012 11:29'!
confirmationTextEditorMorph
	^ confirmationTextEditorMorph! !

!PasswordInitializationDialogWindow methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/7/2012 11:29'!
confirmationTextEditorMorph: anObject
	confirmationTextEditorMorph := anObject! !

!PasswordInitializationDialogWindow methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 5/7/2012 11:32'!
confirmationTextMorph

	^ confirmationTextMorph! !

!PasswordInitializationDialogWindow methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 5/7/2012 11:32'!
confirmationTextMorph: aMorph

	confirmationTextMorph := aMorph! !

!PasswordInitializationDialogWindow methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 5/9/2012 23:09'!
defaultLabel

	^ 'Enter your password'! !

!PasswordInitializationDialogWindow methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/10/2012 13:32'!
enteredValue
	
	^ self cancelled 
		ifTrue: [ nil ]
		ifFalse: [ textEditorMorph text asString ]! !

!PasswordInitializationDialogWindow methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/9/2012 23:30'!
initialize
	"Initialization code for PasswordInitializationDialogWindow"

	super initialize.

	self textFont: UITheme current textFont.! !

!PasswordInitializationDialogWindow methodsFor: 'creation' stamp: 'BenjaminVanRyseghem 5/11/2012 15:55'!
invalidPasswordLabel

	^ LabelMorph new
		text: ''! !

!PasswordInitializationDialogWindow methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/7/2012 11:40'!
newConfirmationTextMorph

	^  'Please confirm your password' asMorph.! !

!PasswordInitializationDialogWindow methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 5/11/2012 15:57'!
newContentMorph
	"Answer a new content morph."

	self iconMorph: self newIconMorph.
	self textMorph: self newTextMorph.
	self confirmationTextMorph: self newConfirmationTextMorph.
	self textMorph wrapFlag: false.
	self textEditorMorph: self newTextEditorMorph.
	self confirmationTextEditorMorph: self newTextEditorMorph.
	^self newGroupboxForAll: {
		self newRow: {self iconMorph. self textMorph}.
		self textEditorMorph.
		self confirmationTextMorph.
		self confirmationTextEditorMorph.
		self newRow: {self showPasswordButton. self buildInvalidPasswordLabel}}! !

!PasswordInitializationDialogWindow methodsFor: 'creation' stamp: 'BenjaminVanRyseghem 5/7/2012 11:28'!
newTextEditorMorph
	"Answer a new morph for the text entry using a password font."
	
	|textEditor|
	textEditor := super newTextEditorMorph.
	textEditor font: (StrikeFont passwordFontSize: self theme textFont pointSize).
	^textEditor! !

!PasswordInitializationDialogWindow methodsFor: 'creation' stamp: 'BenjaminVanRyseghem 5/9/2012 23:07'!
newTextMorph
	"Answer a text morph."
	
	^self newText: 'Please enter your password'! !

!PasswordInitializationDialogWindow methodsFor: 'creation' stamp: 'BenjaminVanRyseghem 5/11/2012 16:06'!
ok
	| boolean |

	boolean := (textEditorMorph textMorph text = confirmationTextEditorMorph textMorph text).
	boolean ifFalse: [ 
		self setInvalidLabel.
		textEditorMorph setText: ''.
		confirmationTextEditorMorph setText: ''.
		^ self ].

	self
		cancelled: false;
		applyChanges;
		delete! !

!PasswordInitializationDialogWindow methodsFor: 'creation' stamp: 'BenjaminVanRyseghem 5/11/2012 16:04'!
setInvalidLabel
						
	self setInvalidLabel: ('passwords are not the same' asMorph color: Color red)! !

!PasswordInitializationDialogWindow methodsFor: 'creation' stamp: 'IgorStasenko 12/20/2012 14:56'!
setInvalidLabel: aString

	container removeAllMorphs.
	container 
		addMorph: aString asMorph
		fullFrame: LayoutFrame identity
						! !

!PasswordInitializationDialogWindow methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/10/2012 23:44'!
showPassword
	
	^ showPassword ifNil: [ showPassword := false ]! !

!PasswordInitializationDialogWindow methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/10/2012 23:44'!
showPassword: aBoolean

	(showPassword := aBoolean)
		ifTrue: [ self beDecrypted ]
		ifFalse: [ self beEncrypted ].
	self changed: #showPassword! !

!PasswordInitializationDialogWindow methodsFor: 'creation' stamp: 'BenjaminVanRyseghem 5/10/2012 23:44'!
showPasswordButton

	^ (CheckboxMorph 
			on: self 
			selected: #showPassword
			changeSelected: #showPassword:)
			label: 'Show password';
			labelClickable: true;
			height: 25.! !

Object subclass: #AbstractEcryptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KeyChain'!

!AbstractEcryptor commentStamp: '<historical>' prior: 0!
An AbstractEcryptor is an interface for encryptor.

It's basically just an algorithm to encrypt a string, without ensuring it can be decrypted!

!AbstractEcryptor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/6/2012 22:08'!
encrypt: aString

	^ self subclassResponsibility! !

AbstractEcryptor subclass: #DummyEcryptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KeyChain'!

!DummyEcryptor commentStamp: '<historical>' prior: 0!
A DummyEcryptor is an encryptor that just do _NOT_ encrypt at all :)!

!DummyEcryptor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/6/2012 22:08'!
encrypt: aString

	^ aString! !

AbstractEcryptor subclass: #SHA1Ecryptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KeyChain'!

!SHA1Ecryptor commentStamp: '<historical>' prior: 0!
A SHA1Ecryptor is an encryptor using SHA1 algorithm!

!SHA1Ecryptor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/9/2012 11:43'!
encrypt: aString

	^ SecureHashAlgorithm new hashMessage: aString! !

Object subclass: #AbstractEcryptorDecryptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KeyChain'!

!AbstractEcryptorDecryptor commentStamp: '<historical>' prior: 0!
An AbstractEcryptorDecryptor is an interface providing the method for encrypting/decrypting a string!

!AbstractEcryptorDecryptor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/6/2012 22:07'!
decrypt: aString base: aBase

	^ self subclassResponsibility! !

!AbstractEcryptorDecryptor methodsFor: 'protocol' stamp: 'Camillo 5/15/2012 11:21'!
encrypt: aString base: aBase

	^ self subclassResponsibility! !

AbstractEcryptorDecryptor subclass: #CaesarEcryptorDecryptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KeyChain'!

!CaesarEcryptorDecryptor commentStamp: '<historical>' prior: 0!
A CaesarEcryptorDecryptor is a world know encryptng algorithm by rotation!

!CaesarEcryptorDecryptor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/6/2012 22:41'!
decrypt: aString base: aBase

	^ String streamContents: [:s | 
		aString do: [:c | s nextPut: ( Character value: (c asciiValue - aBase size )) ]]! !

!CaesarEcryptorDecryptor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/6/2012 22:42'!
encrypt: aString base: aBase

	^ String streamContents: [:s | 
		aString do: [:c | s nextPut: ( Character value: (c asciiValue + aBase size )) ]]! !

AbstractEcryptorDecryptor subclass: #DummyEcryptorDecryptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KeyChain'!

!DummyEcryptorDecryptor commentStamp: '<historical>' prior: 0!
A DummyEcryptorDecryptor is  an encryptor that just do _NOT_ encrypt/decrypt at all :)!

!DummyEcryptorDecryptor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/6/2012 22:07'!
decrypt: aString base: aBase

	^ aString! !

!DummyEcryptorDecryptor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/6/2012 22:07'!
encrypt: aString base: aBase

	^ aString! !

Object subclass: #Cookie
	instanceVariableNames: 'contents timeToLive hourGlass defaultValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KeyChain'!

!Cookie commentStamp: '<historical>' prior: 0!
A Cookie is a simple object which kept a value during a defined amount of time.!

!Cookie methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/6/2012 23:18'!
contents

	^ contents! !

!Cookie methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/9/2012 16:31'!
contents: anObject

	contents := anObject.
	hourGlass ifNotNil: [ hourGlass terminate ].
	hourGlass := [
		(Delay forMilliseconds: timeToLive asMilliSeconds) wait.
		contents := defaultValue ] fork.! !

!Cookie methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/6/2012 23:22'!
defaultTimeToLive

	^ Duration minutes: 2! !

!Cookie methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/6/2012 23:32'!
defaultValue: anObject

	contents = defaultValue ifTrue: [ contents := anObject ].
	defaultValue := anObject! !

!Cookie methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/6/2012 23:30'!
initialize
	"Initialization code for Cookie"

	super initialize.

	timeToLive := self defaultTimeToLive.
	defaultValue := nil.
	contents := defaultValue.! !

!Cookie methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 12:59'!
timeToLive

	^ timeToLive! !

!Cookie methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/6/2012 23:31'!
timeToLive: aDuration

	timeToLive := aDuration! !

Cookie subclass: #EternalCookie
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KeyChain'!

!EternalCookie commentStamp: '<historical>' prior: 0!
An EternalCookie is a cookie that live forever.

Actualy not eternal, but will last one year!

!EternalCookie methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/9/2012 10:35'!
defaultTimeToLive

	^ Year new duration! !

Object subclass: #KeyChain
	instanceVariableNames: 'username password encryptor lastUnlock encryptorDecryptor bindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KeyChain'!

!KeyChain commentStamp: '<historical>' prior: 0!
A KeyChain is a holder for username/password.
It can be queried by the system to prevent the user to be forced to set his or her password each time.

keys have this structure:

|- group1 (by example squeaksource) 	-> (username -> password)
|- group2 (by example smalltalkhub) 		-> (username -> password)!

!KeyChain methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/9/2012 22:08'!
askPasswordForKeyChain: attempt
	| string |
	
	password ifNil: [ ^ lastUnlock contents: true ].
	string := UITheme current 
				passwordEntryIn: StandardWindow new 
				text: 'Password for the keychain for ', username asString ,' (', (self maxAttemptsNumber - attempt) asString ,' tries left)'
				title: 'Password request'
				entryText: ''.
	string ifNil: [ ^ self ].		
	(encryptor encrypt: string) = password ifFalse: [ ^ self ].

	lastUnlock contents: true! !

!KeyChain methodsFor: 'private-UI' stamp: 'BenjaminVanRyseghem 5/10/2012 13:28'!
bindings

	^ bindings! !

!KeyChain methodsFor: 'encryption' stamp: 'BenjaminVanRyseghem 5/6/2012 22:26'!
decryptPassword: aString

	^ encryptorDecryptor decrypt: aString base: password! !

!KeyChain methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/6/2012 23:35'!
defaultTimeBetweenUnlocks
	" 5 minutes "
	
	^ Duration minutes: 5! !

!KeyChain methodsFor: 'encryption' stamp: 'BenjaminVanRyseghem 5/6/2012 22:10'!
encryptPassword: aString

	^ encryptorDecryptor encrypt: aString base: password! !

!KeyChain methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/9/2012 13:25'!
groups

	^ bindings keys! !

!KeyChain methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/9/2012 16:40'!
initialize
	"Initialization code for KeyChain"

	super initialize.

	bindings := IdentityDictionary new.
	
	encryptor := SHA1Ecryptor new.
	encryptorDecryptor := DummyEcryptorDecryptor new.
	
	password := nil.
	
	lastUnlock := Cookie new
					defaultValue: false;
					timeToLive: self defaultTimeBetweenUnlocks;
					yourself.! !

!KeyChain methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/11/2012 18:04'!
isLocked

	^ true! !

!KeyChain methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/9/2012 16:20'!
isUnlocked

	^ self isUnlocked: 0! !

!KeyChain methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/9/2012 16:21'!
isUnlocked: attempt

	^ lastUnlock contents
		ifTrue: [ true ]
		ifFalse: [ 
			attempt = self maxAttemptsNumber ifTrue: [ ^ false ].
			self askPasswordForKeyChain: attempt.
			self isUnlocked: (attempt +1) ]! !

!KeyChain methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/20/2012 03:25'!
lock

	lastUnlock contents: false.! !

!KeyChain methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/9/2012 16:19'!
maxAttemptsNumber

	^ 3! !

!KeyChain methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/9/2012 13:25'!
passwordFor: aUserName

	^ self isUnlocked
		ifTrue: [ self decryptPassword: (bindings at: aUserName) ]! !

!KeyChain methodsFor: 'encryption' stamp: 'BenjaminVanRyseghem 5/9/2012 13:25'!
reEncryptKeysBased: aFormerBase

	bindings associations do: [:assoc || oldUsernamePassword string |
				oldUsernamePassword := bindings at: assoc key.
				string := encryptorDecryptor decrypt: oldUsernamePassword password base: aFormerBase.
				bindings at: assoc key put: ( UsernamePassword username: oldUsernamePassword username password: (self encryptPassword: string) )]! !

!KeyChain methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/10/2012 13:55'!
removeUserNamePasswordFor: aGroup

	^ self isUnlocked
		ifTrue: [ bindings removeKey: aGroup ]! !

!KeyChain methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/9/2012 13:25'!
setEncryptorDecryptor: anEncryptorDecryptor

	self isUnlocked 	
		ifTrue: [ | oldDecryptor |
			oldDecryptor := encryptorDecryptor.
			encryptorDecryptor := anEncryptorDecryptor .
			bindings associations do: [:assoc || oldUsernamePassword string |
				oldUsernamePassword := bindings at: assoc key.
				string := oldDecryptor decrypt: oldUsernamePassword password base: password.
				bindings at: assoc key put: ( UsernamePassword username: oldUsernamePassword username password: (self encryptPassword: string) )]]! !

!KeyChain methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/9/2012 13:10'!
setPassword: aPassword

	(password isNil or: [ self isUnlocked ])
		ifTrue: [ | oldPassword |
			oldPassword := password.
			password := encryptor encrypt: aPassword.
			"Since the passwords are encoded using the password, if you change the password, you have to re-encrypt the passwords"
			self reEncryptKeysBased: oldPassword ]! !

!KeyChain methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/9/2012 16:45'!
setUserName: user password: pass forGroup: group

	self isUnlocked
		ifTrue: [ 
			bindings 
				at: group 
				put: (UsernamePassword 
							username: user 
							password: (self encryptPassword: pass)).
			^ true ].
	^ false! !

!KeyChain methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/9/2012 16:45'!
setUserName: user password: pass forGroup: group withUnlockPassword: aString

	(encryptor encrypt: aString) = password 
		ifTrue: [ bindings 
					at: group 
					put: (UsernamePassword 
								username: user 
								password: (self encryptPassword: pass)).
								
				^ true ].
	^ false! !

!KeyChain methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem2 5/11/2012 18:21'!
setUserNamePassword: usernamePassword forGroup: group

	self isUnlocked
		ifTrue: [ 
			bindings 
				at: group 
				put: usernamePassword.
			^ true ].
	^ false! !

!KeyChain methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/9/2012 12:59'!
timeBetweenUnlocks

	^ lastUnlock timeToLive! !

!KeyChain methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/9/2012 12:59'!
timeBetweenUnlocks: aDuration

	lastUnlock timeToLive: aDuration! !

!KeyChain methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/11/2012 16:37'!
unlock

	^ self isUnlocked ! !

!KeyChain methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/9/2012 16:43'!
userNamePasswordFor: aGroup

	^ self isUnlocked
		ifTrue: [ | oldUsernamePassword |
			oldUsernamePassword := bindings at: aGroup ifAbsent: [ ^ nil ].
			UsernamePassword username: oldUsernamePassword username password: (self decryptPassword: (oldUsernamePassword password)) ]! !

!KeyChain methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 13:16'!
username

	^ username! !

!KeyChain methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 13:16'!
username: aString

	username := aString ! !

KeyChain subclass: #UnlockedKeyChain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KeyChain'!

!UnlockedKeyChain commentStamp: '<historical>' prior: 0!
An UnlockedKeyChain is a keychain with no password.

It stores values that anyone can access!

!UnlockedKeyChain methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/11/2012 18:04'!
isLocked

	^ false! !

!UnlockedKeyChain methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/11/2012 13:47'!
isUnlocked

	^ true! !

!UnlockedKeyChain methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/11/2012 13:50'!
setUserName: user forGroup: group

	self 
		setUserName: user 
		password: nil 
		forGroup: group! !

!UnlockedKeyChain methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/11/2012 13:48'!
setUserName: user password: pass forGroup: group

	self isUnlocked
		ifTrue: [ 
			bindings 
				at: group 
				put: (UsernamePassword 
							username: user 
							password: nil).
			^ true ].
	^ false! !

!UnlockedKeyChain methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/11/2012 13:48'!
setUserName: user password: pass forGroup: group withUnlockPassword: aString

	(encryptor encrypt: aString) = password 
		ifTrue: [ bindings 
					at: group 
					put: (UsernamePassword 
								username: user 
								password:nil).
								
				^ true ].
	^ false! !

!UnlockedKeyChain methodsFor: 'protocol' stamp: 'bvr 5/11/2012 16:30'!
userNameFor: aGroup

	^ self isUnlocked
		ifTrue: [ (bindings at: aGroup ifAbsent: [ ^ nil ]) username ]! !

!UnlockedKeyChain methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/11/2012 14:07'!
userNamePasswordFor: aGroup

	^ self userNameFor: aGroup! !

Object subclass: #KeychainEditingWrapper
	instanceVariableNames: 'keychain group usernamePassword'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KeyChain-UI'!

!KeychainEditingWrapper commentStamp: '<historical>' prior: 0!
A KeychainEditingWrapper is a simple wrapper for the KeychainEditor !

!KeychainEditingWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/11/2012 17:46'!
group
	^ group! !

!KeychainEditingWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/11/2012 17:46'!
group: anObject
	group := anObject! !

!KeychainEditingWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/11/2012 17:46'!
keychain
	^ keychain! !

!KeychainEditingWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/11/2012 17:46'!
keychain: anObject
	keychain := anObject! !

!KeychainEditingWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/11/2012 17:46'!
usernamePassword
	^ usernamePassword! !

!KeychainEditingWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/11/2012 17:46'!
usernamePassword: anObject
	usernamePassword := anObject! !

Object subclass: #PharoUser
	instanceVariableNames: 'avatar username keychain unlockedKeychain permissions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KeyChain'!

!PharoUser commentStamp: '<historical>' prior: 0!
A PharoUser is a simple object with a username and an avatar.

It also works as a factory to keep already generated instances!

!PharoUser class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 12/12/2012 11:23'!
username: username

	^ UsersManager default users
		detect: [:e | e username = username ] 
		ifNone: [	
			self new
				username: username;
				yourself ]! !

!PharoUser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 13:55'!
avatar
	^ avatar! !

!PharoUser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 16:27'!
avatar: email

	self updateGravatarFor: email! !

!PharoUser methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/16/2012 15:40'!
defaultAvatar

	^ ImageMorph new
		color: Color transparent;
		height: 1;
		width: 1;
		yourself ! !

!PharoUser methodsFor: 'error handling' stamp: 'BenjaminVanRyseghem 5/16/2012 15:04'!
doesNotUnderstand: aMessage

	^ [ self permissions perform: aMessage selector withEnoughArguments: aMessage arguments ] 
		on: MessageNotUnderstood 
		do: [ super doesNotUnderstand: aMessage ]! !

!PharoUser methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/16/2012 15:55'!
initialize
	"Initialization code for PharoUser"

	super initialize.

	avatar := self defaultAvatar.
	self updateGravatarFor: ''.
	keychain := KeyChain new.
	unlockedKeychain := UnlockedKeyChain new.! !

!PharoUser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 16:11'!
keychain

	^ keychain! !

!PharoUser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/20/2012 03:25'!
lock

	^ keychain lock! !

!PharoUser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/16/2012 15:02'!
permissions

	^ permissions ifNil: [ permissions := PharoUserPermissions new ]! !

!PharoUser methodsFor: 'printing' stamp: 'BenjaminVanRyseghem 5/9/2012 14:03'!
printOn: aStream

	super printOn: aStream.
	aStream nextPut: $(.
	username printOn: aStream.
	aStream nextPut: $)! !

!PharoUser methodsFor: 'gravatar' stamp: 'BenjaminVanRyseghem 5/9/2012 17:00'!
retrieveGravatarFromMail: email

	^ self retrieveGravatarFromMail: email size: 120! !

!PharoUser methodsFor: 'gravatar' stamp: 'SvenVanCaekenberghe 1/15/2013 15:48'!
retrieveGravatarFromMail: email size: size
	| response |
	response := ZnClient new
		timeout: 10;
		url: 'http://www.gravatar.com/avatar';
		addPathSegment: (ZnDigestAuthenticator md5Hash: email);
		queryAt: #s put: size asString;
		queryAt: #d put: #retro;
		get.
	^ ImageMorph fromStream: response readStream! !

!PharoUser methodsFor: 'protocol-forward' stamp: 'BenjaminVanRyseghem 5/9/2012 16:11'!
setPassword: aString

	^ self keychain setPassword: aString ! !

!PharoUser methodsFor: 'protocol-forward' stamp: 'BenjaminVanRyseghem 5/11/2012 16:40'!
setUserName: user forGroup: group

	^ self unlockedKeychain 
			setUserName: user 
			forGroup: group! !

!PharoUser methodsFor: 'protocol-forward' stamp: 'BenjaminVanRyseghem 5/9/2012 16:11'!
setUserName: user password: pass forGroup: group

	^ self keychain setUserName: user password: pass forGroup: group! !

!PharoUser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/11/2012 16:37'!
unlock

	^ keychain unlock! !

!PharoUser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/11/2012 16:40'!
unlockedKeychain

	^ unlockedKeychain! !

!PharoUser methodsFor: 'gravatar' stamp: 'BenjaminVanRyseghem 5/9/2012 22:11'!
updateGravatarFor: email
	| newAvatar |
	
	newAvatar := [ self retrieveGravatarFromMail: email ]
					on: Error
					do: [ nil ].
					
	newAvatar ifNotNil: [ avatar := newAvatar ].! !

!PharoUser methodsFor: 'protocol-forward' stamp: 'BenjaminVanRyseghem 5/11/2012 16:40'!
userNameFor: aGroup

	^ self unlockedKeychain userNameFor: aGroup ! !

!PharoUser methodsFor: 'protocol-forward' stamp: 'BenjaminVanRyseghem 5/9/2012 16:11'!
userNamePasswordFor: aGroup

	^ self keychain userNamePasswordFor: aGroup ! !

!PharoUser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 13:55'!
username
	^ username! !

!PharoUser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 13:55'!
username: anObject
	username := anObject! !

Object subclass: #PharoUserPermissions
	instanceVariableNames: 'canBrowse canDebug canDropOSFile canEditCode canEvaluateCode canInspect canRunStartupScript canShowMorphHalo canEditUser'
	classVariableNames: 'PharoUsers'
	poolDictionaries: ''
	category: 'KeyChain'!

!PharoUserPermissions commentStamp: '<historical>' prior: 0!
A PharoUserPermissions is a wrapper which stores the permissions of a PharoUser!

!PharoUserPermissions methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 11:35'!
canBrowse
	^ canBrowse! !

!PharoUserPermissions methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 11:35'!
canBrowse: anObject
	canBrowse := anObject! !

!PharoUserPermissions methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 11:35'!
canDebug
	^ canDebug! !

!PharoUserPermissions methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 11:35'!
canDebug: anObject
	canDebug := anObject! !

!PharoUserPermissions methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 11:35'!
canDropOSFile
	^ canDropOSFile! !

!PharoUserPermissions methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 11:35'!
canDropOSFile: anObject
	canDropOSFile := anObject! !

!PharoUserPermissions methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 11:35'!
canEditCode
	^ canEditCode! !

!PharoUserPermissions methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 11:35'!
canEditCode: anObject
	canEditCode := anObject! !

!PharoUserPermissions methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 13:50'!
canEditUser

	^ canEditUser! !

!PharoUserPermissions methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 13:50'!
canEditUser: anObject
	canEditUser := anObject! !

!PharoUserPermissions methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 11:35'!
canEvaluateCode
	^ canEvaluateCode! !

!PharoUserPermissions methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 11:35'!
canEvaluateCode: anObject
	canEvaluateCode := anObject! !

!PharoUserPermissions methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 11:35'!
canInspect
	^ canInspect! !

!PharoUserPermissions methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 11:35'!
canInspect: anObject
	canInspect := anObject! !

!PharoUserPermissions methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 11:35'!
canRunStartupScript
	^ canRunStartupScript! !

!PharoUserPermissions methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 11:35'!
canRunStartupScript: anObject
	canRunStartupScript := anObject! !

!PharoUserPermissions methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 11:35'!
canShowMorphHalo
	^ canShowMorphHalo! !

!PharoUserPermissions methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 11:35'!
canShowMorphHalo: anObject
	canShowMorphHalo := anObject! !

!PharoUserPermissions methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/21/2012 13:52'!
initialize
	"Initialization code for PharoUserPermissions"

	super initialize.

	canBrowse := false.
	canDebug := false.
	canDropOSFile := false.
	canEditCode := false.
	canEvaluateCode := false.
	canInspect := false.
	canRunStartupScript := false.
	canShowMorphHalo := false.
	canEditUser := false.! !

!PharoUserPermissions methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/2/2012 16:02'!
isRoot: aBoolean

	canBrowse := aBoolean.
	canDebug := aBoolean.
	canDropOSFile := aBoolean.
	canEditCode := aBoolean.
	canEvaluateCode := aBoolean.
	canInspect := aBoolean.
	canRunStartupScript := aBoolean.
	canShowMorphHalo := aBoolean.
	canEditUser := aBoolean.! !

Object subclass: #UsernamePassword
	instanceVariableNames: 'password username'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KeyChain'!

!UsernamePassword commentStamp: '<historical>' prior: 0!
An UsernamePassword is just a simple wrapper!

!UsernamePassword class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 5/9/2012 10:50'!
username: username password: password

	^ self new
		password: password;
		username: username;
		yourself! !

!UsernamePassword methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem2 5/11/2012 18:26'!
= another

	self species = another species ifFalse: [ ^ false ].
	^ self username = another username and: [ self password = another password ]! !

!UsernamePassword methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 10:50'!
password
	^ password! !

!UsernamePassword methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 10:50'!
password: anObject
	password := anObject! !

!UsernamePassword methodsFor: 'printing' stamp: 'BenjaminVanRyseghem 5/11/2012 18:07'!
printOn: aStream

	super printOn: aStream.
	
	aStream 
		nextPutAll: '(';
		nextPutAll: username printString;
		nextPutAll: ' -> ';
		nextPutAll: password asString;
		nextPutAll: ')';
		yourself! !

!UsernamePassword methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 10:50'!
username
	^ username! !

!UsernamePassword methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 10:50'!
username: anObject
	username := anObject! !

Object subclass: #UsersManager
	instanceVariableNames: 'currentUser users'
	classVariableNames: 'DefaultUserManager'
	poolDictionaries: ''
	category: 'KeyChain'!

!UsersManager commentStamp: '<historical>' prior: 0!
An UsersManager is xxxxxxxxx.

|- user1 -> keyChain1
|- user2 -> keyChain2!

!UsersManager class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 5/9/2012 13:00'!
default

	^ DefaultUserManager ifNil: [ DefaultUserManager := self new ]! !

!UsersManager class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 5/9/2012 13:06'!
resetDefault

	DefaultUserManager := nil! !

!UsersManager class methodsFor: 'menu' stamp: 'EstebanLorenzano 12/6/2012 13:47'!
switchUsers2: aBuilder 
	"I build a menu"
	"<worldMenu>"
	(aBuilder item: #'Switch User tests').
	
	(aBuilder item: #'Test Halt')
		parent: #'Switch User tests';
		action: [ self halt ].
	(aBuilder item: #'Test DNU')
		parent: #'Switch User tests';
		action: [ self DNU ].
	(aBuilder item: #'Test inspect')
		parent: #'Switch User tests';
		action: [ self inspect ]! !

!UsersManager class methodsFor: 'menu' stamp: 'EstebanLorenzano 12/6/2012 18:39'!
switchUsers: aBuilder 
	"I build a menu"
	<worldMenu>
	(aBuilder item: #'Switch User')
		parent: #System;
		order: 1.5;
		icon: (UITheme current iconNamed: #userIcon);
		action: [ self default openSwitchUsers ]! !

!UsersManager methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/12/2012 11:41'!
addDefaultUser
	| user |
	
	user := PharoUser new 
		username: 'root';
		yourself.
	user isRoot: true.
	
	self addUser: user.
	^ user! !

!UsersManager methodsFor: 'protocol' stamp: 'EstebanLorenzano 12/6/2012 18:58'!
addUser: aPharoUser
	
	users add: aPharoUser.
	users size = 1
		ifTrue: [ self setCurrentUser: aPharoUser ].
	aPharoUser  keychain
			username: aPharoUser username.

	^ aPharoUser! !

!UsersManager methodsFor: 'protocol' stamp: 'EstebanLorenzano 12/6/2012 18:57'!
addUser: aName password: aPassword
	| user |
	
	user := (PharoUser username: aName).
	user keychain setPassword: aPassword.
			
	^ self addUser: user! !

!UsersManager methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/11/2012 15:40'!
addUser: aName password: aPassword gravatarMail: email
	| user |
	
	user := self addUser: aName password: aPassword.
	user avatar: email.
	user 
		setUserName: email
		forGroup: #gravatar! !

!UsersManager methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/16/2012 15:19'!
currentUser

	^ currentUser! !

!UsersManager methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/9/2012 16:14'!
groupsFor: anUser

	^ self currentUser keychain groups! !

!UsersManager methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/16/2012 15:19'!
initialize
	"Initialization code for UsersManager"

	super initialize.

	users := SortedCollection new 
					sortBlock: [:a :b | a username printString < b username printString ];
					asValueHolder.
	
	currentUser := nil.
	self addDefaultUser.! !

!UsersManager methodsFor: '*KeyChain-UI' stamp: 'BenjaminVanRyseghem 8/2/2012 15:37'!
openSwitchUsers

	SwitchUsers new
		usersManager:  self;
		openDialogWithSpec! !

!UsersManager methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/16/2012 15:11'!
removeUser: aName
	
	users remove: aName! !

!UsersManager methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/9/2012 11:45'!
setCurrentUser: aName
	
	currentUser := aName! !

!UsersManager methodsFor: 'protocol-forward' stamp: 'BenjaminVanRyseghem 5/9/2012 16:14'!
setPassword: aString

	^ self currentUser setPassword: aString ! !

!UsersManager methodsFor: 'protocol-forward' stamp: 'BenjaminVanRyseghem 5/9/2012 16:14'!
setUserName: user password: pass forGroup: group

	^ self currentUser setUserName: user password: pass forGroup: group! !

!UsersManager methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/11/2012 15:34'!
userNameFor: aGroup

	^ self currentUser userNameFor: aGroup ! !

!UsersManager methodsFor: 'protocol-forward' stamp: 'BenjaminVanRyseghem 5/9/2012 16:14'!
userNamePasswordFor: aGroup

	^ self currentUser userNamePasswordFor: aGroup ! !

!UsersManager methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/6/2012 19:05'!
userNames
	^ self users collect: #username! !

!UsersManager methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/16/2012 15:11'!
users

	^ users! !

ComposableModel subclass: #KeyChainViewer
	instanceVariableNames: 'add edit keychain list remove ok'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KeyChain-UI'!

!KeyChainViewer commentStamp: '<historical>' prior: 0!
A KeyChainViewer is a GUI to see and edit values of a keychain!

!KeyChainViewer class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/15/2013 13:47'!
internSpec
	<spec>
	
	^{#ComposableSpec.
			#add:. {{#model. #list }. #layout:.  #(FrameLayout
													bottomOffset: -50)}.
			 #add:. {{#model. #add }. #layout:.  #(FrameLayout
													topFraction: 1
													rightFraction: 0
													topOffset: -50
													rightOffset: 50
													bottomOffset: -25) }.
			#add:. {{#model. #edit }. #layout:. #(FrameLayout
													topFraction: 1
													leftOffset: 50
													topOffset: -50
													rightOffset: -50
													bottomOffset: -25) }.
			#add:. {{#model. #remove }. #layout:.  #(FrameLayout
													leftFraction: 1
													topFraction: 1
													leftOffset: -50
													topOffset: -50
													bottomOffset: -25) }.
			#add:. {{#model. #ok }. #layout: . #(FrameLayout
													topFraction: 1
													topOffset: -25) }}! !

!KeyChainViewer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2012 13:26'!
add
	^ add! !

!KeyChainViewer methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/2/2012 16:47'!
addPassword

	| wrapper editor group user index |
	keychain contents ifNotNil:[:kc | kc unlock ].
	wrapper :=  KeychainEditingWrapper new
					keychain: keychain contents;
					group: '';
					usernamePassword: UsernamePassword new.
					
	editor := KeychainEditor new
				keychainEditingWrapper: wrapper;
				yourself.
	self window ifNotNil: [: w | w openModal: editor openDialogWithSpec window].
	editor cancelled ifTrue: [ ^ self ].
	
	group := wrapper group.
	user :=wrapper usernamePassword.
	keychain contents setUserNamePassword: user forGroup: group.
	keychain contentsChanged.
	index := list listItems indexOf: (group -> user ).
	list setSelectedIndex: index! !

!KeyChainViewer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2012 13:26'!
edit
	^ edit! !

!KeyChainViewer methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/2/2012 16:33'!
editPassword

	list selectedItem
		ifNil: [ ^ self ]
		ifNotNil: [:it || wrapper editor |
			keychain contents ifNotNil:[:kc | kc unlock ].
			wrapper :=  KeychainEditingWrapper new
							keychain: keychain contents;
							group: it key;
							usernamePassword: it value.
							
			editor := KeychainEditor new
						keychainEditingWrapper: wrapper;
						yourself.
			self window ifNotNil: [: w | w openModal: editor openDialogWithSpec window ].
			editor cancelled ifTrue: [ ^ self ].
			it key: wrapper group.
			it value: wrapper usernamePassword.
			keychain contentsChanged.
			list setSelectedItem: it ]! !

!KeyChainViewer methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/10/2012 16:18'!
initialExtent 

	^  (320@240)! !

!KeyChainViewer methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 15:27'!
initialize
	"Initialization code for KeyChainViewer"

	keychain := nil asValueHolder.
	
	super initialize.! !

!KeyChainViewer methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/10/2012 13:44'!
initializeAdd

	add
		label: '+';
		enabled: false;
		state: false;
		action: [ self addPassword ]! !

!KeyChainViewer methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/10/2012 13:44'!
initializeEdit

	edit
		label: 'edit';
		enabled: false;
		state: false;
		action: [ self editPassword ]! !

!KeyChainViewer methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/10/2012 13:44'!
initializeRemove

	remove
		label: '-';
		enabled: false;
		state: false;
		action: [ self removePassword ]! !

!KeyChainViewer methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 16:27'!
initializeWidgets
	"Initialization code for KeyChainViewer"

	self instantiateModels: #(
		add ButtonModel
		edit ButtonModel
		list MultiColumnListModel
		ok OkToolbar
		remove ButtonModel ).
	
	self initializeAdd.
	self initializeEdit.
	self initializeRemove.
	ok okButton label: 'Close'.
	list displayBlock: [ :item | self wrapItem: item ].
	
	keychain whenChangedDo: [:kc | 
		add enabled: kc notNil.
		list resetSelection.
		self updateTitle.
		list items: kc bindings associations ].
	
	list whenSelectedItemChanged: [:it |
		edit enabled: it notNil.
		remove enabled: it notNil ].
	
	self focusOrder 
		add: list;
		add: add;
		add: edit;
		add: remove;
		add: ok.! !

!KeyChainViewer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2012 13:26'!
keychain
	^ keychain! !

!KeyChainViewer methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/10/2012 13:19'!
keychain: aKeyChain

	keychain contents: aKeyChain! !

!KeyChainViewer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2012 13:26'!
list
	^ list! !

!KeyChainViewer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2012 13:26'!
ok
	^ ok! !

!KeyChainViewer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2012 13:26'!
remove
	^ remove! !

!KeyChainViewer methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/10/2012 13:56'!
removePassword

	list selectedItem 
		ifNil: [ ^self ]
		ifNotNil: [:it | 
			keychain contents removeUserNamePasswordFor: it key.
			keychain contentsChanged ]! !

!KeyChainViewer methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/10/2012 23:46'!
title

	^ keychain contents
		ifNil: [ 'Keychain editor' ]
		ifNotNil: [:kc | kc username
							ifNil: [ 'Keychain editor' ]
							ifNotNil: [:usr |  'Editing ', usr ,'''s keychain' ]]! !

!KeyChainViewer methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/10/2012 13:27'!
wrapItem: anItem

	^ { anItem key. anItem value username }! !

ComposableModel subclass: #KeychainEditor
	instanceVariableNames: 'groupLabel groupTextField setPassword usernameLabel usernameTextField password keychainEditingWrapper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KeyChain-UI'!

!KeychainEditor commentStamp: '<historical>' prior: 0!
A KeychainEditor is a GUI for editing keychain entrie!

!KeychainEditor class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/15/2013 13:44'!
internSpec
	<spec>
	
	^{#ComposableSpec .
			#add: . {{#model . #groupLabel } . #layout: .  #(FrameLayout
																rightFraction: 0
																bottomFraction: 0
																rightOffset: 75
																bottomOffset: 25) }.
			#add: .  {{#model . #groupTextField } .#layout: . #(FrameLayout
																bottomFraction: 0
																leftOffset: 75
																bottomOffset: 25) }.	
			#add: . {{#model . #usernameLabel } . #layout: . #(FrameLayout
																rightFraction: 0
																bottomFraction: 0
																topOffset: 25
																rightOffset: 75
																bottomOffset: 50) }. 
			#add: . {{#model . #usernameTextField } . #layout: . #(FrameLayout
																bottomFraction: 0
																leftOffset: 75
																topOffset: 25
																bottomOffset: 50) }.
			#add: . {{#model.  #setPassword } . #layout: . #(FrameLayout
																bottomFraction: 0
																topOffset: 50
																bottomOffset: 75) }}! !

!KeychainEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 8/2/2012 16:45'!
cancelled

	^ self window
		ifNil: [ false ]
		ifNotNil: [:w | w cancelled ]! !

!KeychainEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/11/2012 17:21'!
groupLabel
	^ groupLabel! !

!KeychainEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/11/2012 17:21'!
groupTextField
	^ groupTextField! !

!KeychainEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/2/2012 16:41'!
initialExtent

	^  330@150! !

!KeychainEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 15:21'!
initialize
	"Initialization code for KeychainEditor"

	keychainEditingWrapper := nil asValueHolder.
	super initialize.! !

!KeychainEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 16:46'!
initializeDialogWindow: aWindow

	aWindow okAction: [ self ok ].! !

!KeychainEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 15:21'!
initializePresenter 

	keychainEditingWrapper whenChangedDo: [:it |
		groupTextField enabled: it notNil.
		usernameTextField enabled: it notNil.
		setPassword enabled: (it keychain isLocked and: [ it notNil ]).
		it ifNotNil: [
			groupTextField text: it group.
			usernameTextField text: it usernamePassword username.
			password := it usernamePassword password.
			self updateTitle. ]]! !

!KeychainEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 16:51'!
initializeWidgets

	self instantiateModels: #(
		groupLabel  LabelModel
		groupTextField  TextInputFieldModel
		setPassword  ButtonModel
		usernameLabel  LabelModel
		usernameTextField  TextInputFieldModel ).
	
	groupLabel text: 'Group:'.

	groupTextField
		enabled: false;
		autoAccept: true;
		ghostText: 'group'.
		
	usernameLabel text: 'Username: '.

	usernameTextField 
		enabled: false;
		autoAccept: true;
		ghostText: 'username'.
	
	setPassword 
		enabled: false;
		state: false;
		label: 'set password';
		action: [ self setNewPassword ].
		
	self focusOrder
		add: groupTextField;
		add: usernameTextField! !

!KeychainEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/11/2012 17:49'!
keychainEditingWrapper
	^ keychainEditingWrapper! !

!KeychainEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/11/2012 17:49'!
keychainEditingWrapper: anAssociation

	keychainEditingWrapper contents: anAssociation! !

!KeychainEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/11/2012 18:15'!
ok
	| it |
	(it := keychainEditingWrapper contents) ifNil: [ ^ self ].
	
	it group: groupTextField getText asSymbol.
	it usernamePassword username: usernameTextField getText.
	it usernamePassword password: password.! !

!KeychainEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/11/2012 18:01'!
setNewPassword
	| it newPassword w |
	
	(it := keychainEditingWrapper contents) ifNil: [ ^ self ].
	it keychain unlock ifFalse: [ ^ self ].
	
	w := PasswordInitializationDialogWindow new.
	self window openModal: w.
	
	newPassword := w enteredValue.
	newPassword ifNil: [ ^ self ].
	
	password := it keychain encryptPassword: newPassword! !

!KeychainEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/11/2012 17:21'!
setPassword
	^ setPassword! !

!KeychainEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/2/2012 16:50'!
title

	^ keychainEditingWrapper contents
		ifNil: [ 'Group editor' ]
		ifNotNil: [:it | 
			it group 
				ifEmpty: [ 'Group editor' ] 
				ifNotEmpty: [:name |
					'Editing ', name asString printString, ' group' ]]! !

!KeychainEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/11/2012 17:21'!
usernameLabel
	^ usernameLabel! !

!KeychainEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/11/2012 17:21'!
usernameTextField
	^ usernameTextField! !

ComposableModel subclass: #PermissionsEditor
	instanceVariableNames: 'canBrowse canDebug canDropOSFile canEditCode canEditUser canEvaluateCode canInspect canRunStartupScript canShowMorphHalo user isRoot lock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KeyChain-UI'!

!PermissionsEditor commentStamp: '<historical>' prior: 0!
A PermissionsEditor is a GUI for editing a user permissions!

!PermissionsEditor class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/15/2013 13:51'!
internSpec
<spec>

	^{#ComposableSpec.
			#add:. {{#model. #isRoot }.
						#layout:. #(FrameLayout
										bottomFraction: 0
										bottomOffset: 25) }.
			#add:. {{#model. #canBrowse }.
						#layout:. #(FrameLayout
										bottomFraction: 0
										topOffset: 25
										bottomOffset: 50) }.
			#add:. {{#model. #canDebug }.
						#layout:. #(FrameLayout
										bottomFraction: 0
										topOffset: 50
										bottomOffset: 75) }.
			#add:. {{#model. #canDropOSFile }.
						#layout:. #(FrameLayout
										bottomFraction: 0
										topOffset: 75
										bottomOffset: 100)}.
			#add:. {{#model. #canEditCode }.
						#layout:. #(FrameLayout
										bottomFraction: 0
										topOffset: 100
										bottomOffset: 125)}.
			#add:. {{#model. #canEditUser }.
						#layout:. #(FrameLayout
										bottomFraction: 0
										topOffset: 125
										bottomOffset: 150)}.
			#add:. {{#model. #canEvaluateCode }.
						#layout:. #(FrameLayout
										bottomFraction: 0
										topOffset: 150
										bottomOffset: 175)}.
			#add:. {{#model. #canRunStartupScript }.
						#layout:. #(FrameLayout
										bottomFraction: 0
										topOffset: 175
										bottomOffset: 200)}.
			#add:. {{#model. #canShowMorphHalo }.
						#layout:. #(FrameLayout
										bottomFraction: 0
										topOffset: 200
										bottomOffset: 225)}}! !

!PermissionsEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 15:50'!
canBrowse
	^ canBrowse! !

!PermissionsEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 15:50'!
canDebug
	^ canDebug! !

!PermissionsEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 15:50'!
canDropOSFile
	^ canDropOSFile! !

!PermissionsEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 15:50'!
canEditCode
	^ canEditCode! !

!PermissionsEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 15:50'!
canEditUser
	^ canEditUser! !

!PermissionsEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 15:50'!
canEvaluateCode
	^ canEvaluateCode! !

!PermissionsEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 15:50'!
canInspect
	^ canInspect! !

!PermissionsEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 15:50'!
canRunStartupScript
	^ canRunStartupScript! !

!PermissionsEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 15:50'!
canShowMorphHalo
	^ canShowMorphHalo! !

!PermissionsEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/21/2012 16:25'!
checkRoot
	| bool |
	bool := (	(canBrowse state and: [
		canDebug state and: [ 
		canDropOSFile state and: [ 
		canEditCode state and: [ 
		canEditUser state and: [ 
		canEvaluateCode state and: [ 
		canInspect state and: [ 
		canRunStartupScript state and: [ 
		canShowMorphHalo state ]]]]]]]]) = true ) .

	lock := true.
	isRoot state: bool.	

	lock := false! !

!PermissionsEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/21/2012 15:56'!
initialExtent 

	^  (360@300)! !

!PermissionsEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 16:23'!
initialize
	"Initialization code for PermissionsEditor"

	lock := false.
	user := nil asValueHolder.
	
	super initialize.! !

!PermissionsEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/21/2012 14:06'!
initializeCheckBoxes

	self setCanBrowse.
	self setCanDebug.
	self setCanDropOSFile.
	self setCanEditCode.
	self setCanEditUser.
	self setCanEvaluateCode.
	self setCanInspect.
	self setCanRunStartupScript.
	self setCanShowMorphHalo.
	self setIsRoot! !

!PermissionsEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 16:24'!
initializeDialogWindow: aWindow

	aWindow
		okAction: [ 
			user contents
				ifNotNil: [ :usr | 
					usr canBrowse: canBrowse state.
					usr canDebug: canDebug state.
					usr canDropOSFile: canDropOSFile state.
					usr canEditCode: canEditCode state.
					usr canEditUser: canEditUser state.
					usr canEvaluateCode: canEvaluateCode state.
					usr canInspect: canInspect state.
					usr canRunStartupScript: canRunStartupScript state.
					usr canShowMorphHalo: canShowMorphHalo state ] ]! !

!PermissionsEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 16:23'!
initializePresenter
	self registerIsRootEvents.
	self registerUserEvent.! !

!PermissionsEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 16:36'!
initializeWidgets

	isRoot := self instantiate: CheckBoxModel.
	canBrowse := self instantiate: CheckBoxModel.
	canDebug := self instantiate: CheckBoxModel.
	canDropOSFile := self instantiate: CheckBoxModel.
	canEditCode := self instantiate: CheckBoxModel.
	canEditUser := self instantiate: CheckBoxModel.
	canEvaluateCode := self instantiate: CheckBoxModel.
	canInspect := self instantiate: CheckBoxModel.
	canRunStartupScript := self instantiate: CheckBoxModel.
	canShowMorphHalo := self instantiate: CheckBoxModel.
	self initializeCheckBoxes.
	! !

!PermissionsEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/21/2012 15:50'!
isRoot
	^ isRoot! !

!PermissionsEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/21/2012 16:17'!
registerIsRootEvents
	isRoot
		whenChangedDo: [ :bool | 
			lock ifFalse: [ 
					canBrowse state: bool.
					canDebug state: bool.
					canDropOSFile state: bool.
					canEditCode state: bool.
					canEditUser state: bool.
					canEvaluateCode state: bool.
					canInspect state: bool.
					canRunStartupScript state: bool.
					canShowMorphHalo state: bool ]]! !

!PermissionsEditor methodsFor: 'initialize' stamp: 'EstebanLorenzano 12/6/2012 18:46'!
registerUserEvent
	user
		whenChangedDo: [ :usr | 
			self updateTitle.
			canBrowse enabled: usr notNil.
			canDebug enabled: usr notNil.
			canDropOSFile enabled: usr notNil.
			canEditCode enabled: usr notNil.
			canEditUser enabled: usr notNil.
			canEvaluateCode enabled: usr notNil.
			canInspect enabled: usr notNil.
			canRunStartupScript enabled: usr notNil.
			canShowMorphHalo enabled: usr notNil.
			usr ifNotNil: [
				canBrowse state: usr canBrowse.
				canDebug state: usr canDebug.
				canDropOSFile state: usr canDropOSFile.
				canEditCode state: usr canEditCode.
				canEditUser state: usr canEditUser.
				canEvaluateCode state: usr canEvaluateCode.
				canInspect state: usr canInspect.
				canRunStartupScript state: usr canRunStartupScript.
				canShowMorphHalo state: usr canShowMorphHalo.
				self checkRoot. ]]! !

!PermissionsEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/21/2012 16:04'!
setCanBrowse
	canBrowse
		state: false;
		enabled: false;
		whenChangedDo: [ self checkRoot ];
		label: 'Can browse code ?'.! !

!PermissionsEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/21/2012 16:05'!
setCanDebug
	canDebug
		state: false;
		enabled: false;
		whenChangedDo: [ self checkRoot ];
		label: 'Can debug code ?'! !

!PermissionsEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/21/2012 16:05'!
setCanDropOSFile
	canDropOSFile
		state: false;
		enabled: false;
		whenChangedDo: [ self checkRoot ];
		label: 'Can drop files into the image from the OS ?'! !

!PermissionsEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/21/2012 16:05'!
setCanEditCode
	canEditCode
		state: false;
		enabled: false;
		whenChangedDo: [ self checkRoot ];
		label: 'Can edit code ?'! !

!PermissionsEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/21/2012 16:05'!
setCanEditUser
	canEditUser
		state: false;
		enabled: false;
		whenChangedDo: [ self checkRoot ];
		label: 'Can user permissions ?'! !

!PermissionsEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/21/2012 16:05'!
setCanEvaluateCode
	canEvaluateCode
		state: false;
		enabled: false;
		whenChangedDo: [ self checkRoot ];
		label: 'Can evaluate code ?'! !

!PermissionsEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/21/2012 16:05'!
setCanInspect
	canInspect
		state: false;
		enabled: false;
		whenChangedDo: [ self checkRoot ];
		label: 'Can inspect object ?'! !

!PermissionsEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/21/2012 16:05'!
setCanRunStartupScript
	canRunStartupScript
		state: false;
		enabled: false;
		whenChangedDo: [ self checkRoot ];
		label: 'Can run script from the OS ?'! !

!PermissionsEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/21/2012 16:05'!
setCanShowMorphHalo
	canShowMorphHalo
		state: false;
		enabled: false;
		whenChangedDo: [ self checkRoot ];
		label: 'Can show halo of morphs ?'! !

!PermissionsEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/21/2012 14:06'!
setIsRoot

	isRoot
		state: false;
		enabled: false;
		label: 'Is this user root ?'! !

!PermissionsEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/21/2012 15:48'!
title

	^ user contents 
			ifNil: 'Permissions editor'
			ifNotNil: [:usr | 'Editing ', usr username, '''s permissions' ]! !

!PermissionsEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/21/2012 13:55'!
user

	^ user contents! !

!PermissionsEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/21/2012 13:55'!
user: anUser

	^ user contents: anUser! !

ComposableModel subclass: #SwitchUsers
	instanceVariableNames: 'add remove users label usersManager selectedUser edit container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KeyChain-UI'!

!SwitchUsers commentStamp: '<historical>' prior: 0!
A SwitchUsers is a GUI to swith the current user!

!SwitchUsers class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 8/2/2012 15:38'!
dialogSpec
	<spec>
	| imageHeight |
	imageHeight := 140.
	
	^ SpecLayout composed
		add: #avatar origin: 0.5@0 corner: 0.5@0 offsetOrigin: (-60)@0 offsetCorner: 60@imageHeight;
		add: #users origin: 0@0 corner: 1@0 offsetOrigin: 0@imageHeight offsetCorner: 0@(imageHeight+25);
		add: #add origin: 0@0 corner: 0@0 offsetOrigin: 0@(imageHeight+25) offsetCorner: 50@(imageHeight+50);
		add: #edit origin: 0@0 corner: 1@0 offsetOrigin: 50@(imageHeight+25) offsetCorner: (-50)@(imageHeight+50);
		add: #remove origin: 1@0 corner: 1@0 offsetOrigin: (-50)@(imageHeight+25) offsetCorner: 0@(imageHeight+50);
		yourself! !

!SwitchUsers class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 5/9/2012 15:42'!
title

	^ 'Switch user'! !

!SwitchUsers methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 14:25'!
add
	^ add! !

!SwitchUsers methodsFor: 'private' stamp: 'EstebanLorenzano 12/6/2012 19:28'!
addUser
	| user editor w userName newPassword |
	
	userName := self askName.
	(self isValidUsername: userName) 
		ifFalse: [ 
			UIManager default inform: 'Username invalid.'.
			^self ].
	
	user := PharoUser username: userName.
	user unlock ifFalse: [ ^ self ].
	
	w := PasswordInitializationDialogWindow new.
	self window openModal: w.
	
	newPassword := w enteredValue.
	newPassword ifNil: [ ^ self ].
	user setPassword: newPassword.
	
	editor := UserEditor new
				user: user ;
				openDialogWithSpec;
				yourself.
				
	self window openModal: editor window window.
	usersManager contents addUser: user.
	
	users setSelectedItem: user username.! !

!SwitchUsers methodsFor: 'private' stamp: 'EstebanLorenzano 12/6/2012 19:22'!
askName
	^UIManager default 
		request: 'Please enter new username'
		initialAnswer: ''
		title: 'New user'! !

!SwitchUsers methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 14:58'!
avatar
	
	^ container! !

!SwitchUsers methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 14:36'!
edit
	^ edit! !

!SwitchUsers methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/2/2012 16:25'!
editUser
	| user editor |
	
	(user := selectedUser contents) ifNil: [ ^ self ].
	usersManager contents
		ifNil: [ user unlock ifFalse: [ ^ self ]]
		ifNotNil: [:uM | uM currentUser canEditUser 
						ifFalse: [ user unlock ifFalse: [ ^ self ]]].
	
	editor := UserEditor new
				user: user;
				usersManager: usersManager contents;
				openDialogWithSpec;
				yourself.
				
	self window openModal: editor window window.
	usersManager contentsChanged! !

!SwitchUsers methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/2/2012 16:27'!
initialExtent

	^  (200@265)! !

!SwitchUsers methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 15:40'!
initialize
	"Initialization code for SwitchUsers"

	usersManager := nil asValueHolder.
	selectedUser := nil asValueHolder.
	
	super initialize.! !

!SwitchUsers methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/9/2012 16:01'!
initializeButtons
	add
		label: '+';
		state: true;
		action: [ self addUser ].
	remove
		label: '-';
		state: false;
		action: [ self removeUser ].
	edit
		label: 'edit';
		state: false;
		action: [ self editUser ]! !

!SwitchUsers methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/9/2012 17:00'!
initializeContainer
	container := PanelMorph new
		height: 120;
		width: 120;
		changeProportionalLayout;
		vResizing: #rigid;
		hResizing: #rigid;
		yourself! !

!SwitchUsers methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 15:41'!
initializeDialogWindow: aWindow

	aWindow 
		okAction: [ self ok ].! !

!SwitchUsers methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 15:22'!
initializePresenter 

	self registerUsersManagerEvents.
	self registerUsersEvents.! !

!SwitchUsers methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 15:40'!
initializeWidgets 
	
	self instantiateModels: #(
		add ButtonModel
		edit ButtonModel
		remove ButtonModel
		users DropListModel ).
	
	self initializeButtons.
	
	self initializeContainer.
	self focusOrder 
		add: users;
		add: add;
		add: edit;
		add: remove! !

!SwitchUsers methodsFor: 'private' stamp: 'EstebanLorenzano 12/6/2012 19:28'!
isValidUsername: aString
	^aString isEmptyOrNil not 
		and: [ (self userNames includes: aString) not ].! !

!SwitchUsers methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 14:25'!
label
	^ label! !

!SwitchUsers methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/20/2012 03:24'!
ok

	selectedUser contents ifNotNil: [:user |
		user unlock ifFalse: [ ^ false ].
		usersManager contents setCurrentUser: user.
		user lock ]! !

!SwitchUsers methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/21/2012 13:51'!
registerUsersEvents

	users
		whenSelectedItemChanged: [ :item |
			(usersManager contents isNil or: [ item isNil ])
				ifTrue: [ remove enabled: false ]
				ifFalse: [ | um isRoot uMUsers |
					um := usersManager contents.
					uMUsers := um users.
					isRoot := um currentUser canEditUser.
					remove enabled: 	((item label ~= um currentUser username) and: 
										[(item notNil and: 
										[ isRoot and: 
										[ uMUsers size >1 ]]) and: 
										[ ((uMUsers detect: [:e | e username = item label ]) canEditUser
												ifTrue: [ (uMUsers reject: [:e | e username = item label ]) anySatisfy: [:e | e canEditUser ]]
												ifFalse: [ true ])]])].
			edit enabled: item notNil ]! !

!SwitchUsers methodsFor: 'initialize' stamp: 'root 5/20/2012 16:58'!
registerUsersManagerEvents

	usersManager
		whenChangedDo: [ :uM || size |
			size := uM users size.
			users items: (uM users collect: [ :e | DropListItem named: e username do: [ self setCurrentUser: e ] ]).
			users setSelectedItem: uM currentUser username.
			add state: size isZero ].
		! !

!SwitchUsers methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 14:25'!
remove
	^ remove! !

!SwitchUsers methodsFor: 'private' stamp: 'EstebanLorenzano 12/6/2012 19:07'!
removeUser
	| user confirm |
	(user := selectedUser contents) ifNil: [ ^ self ].
	
	confirm := UIManager default confirm: 'Are you sure you want to delete ', user username asString, '''s profile?' label: 'Delete'.
	confirm ifFalse: [ ^ self ].
	
	usersManager contents removeUser: user.
	usersManager contentsChanged! !

!SwitchUsers methodsFor: 'private' stamp: 'IgorStasenko 12/20/2012 14:09'!
setCurrentUser: anUser

	| mh |
	selectedUser contents: anUser.
	container removeAllMorphs.
	mh := anUser
		ifNil: [ ImageMorph new ]
		ifNotNil: [:user | user avatar copy ].
							
	container addMorph: mh fullFrame: LayoutFrame identity! !

!SwitchUsers methodsFor: 'private' stamp: 'EstebanLorenzano 12/6/2012 19:27'!
userNames
	^UsersManager default userNames! !

!SwitchUsers methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 14:25'!
users
	^ users! !

!SwitchUsers methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 14:25'!
usersManager
	^ usersManager! !

!SwitchUsers methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/9/2012 22:32'!
usersManager: anUsersManager

	usersManager contents: anUsersManager.
	anUsersManager users whenChangedDo: [ usersManager contentsChanged ]! !

ComposableModel subclass: #UserEditor
	instanceVariableNames: 'container userName gravatarAddress setPassword testGravatar gravatarLabel user originalEmail editPublic editPrivate editPermissions usersManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KeyChain-UI'!

!UserEditor commentStamp: '<historical>' prior: 0!
An UserEditor is a GUI for editing a user profile!

!UserEditor class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/15/2013 14:47'!
internSpec
	<spec>
	| imageHeight |
	imageHeight := 140.
	
	^{#ComposableSpec.
			#add:. {	{#model. #avatar}.
							#layout:.{#FrameLayout.
											#leftFraction:. 0.5 .
											#rightFraction:. 0.5 .
											#bottomFraction:.  0 .
											#leftOffset:.  (-60) .
											#rightOffset:.  60 .
											#bottomOffset:.  imageHeight .}}.
			#add:. {	{#model. #userName }.
							#layout:.{#FrameLayout.
											#bottomFraction:.  0 .
											#topOffset:.  imageHeight  .
											#rightOffset:.  (-100) .
											#bottomOffset:.  (imageHeight+25) .}}.
			#add:. {	{#model. #setPassword }.
							#layout:. {#FrameLayout.
											#leftFraction:.  1 .
											#bottomFraction:.  0 .
											#leftOffset:.  (-100) .
											#topOffset:.  imageHeight  .
											#bottomOffset:.  (imageHeight+25) .}}.
			#add:. {	{#model. #gravatarAddress }.
							#layout:. {#FrameLayout.
											#bottomFraction:.  0 .
											#topOffset:.  (25+imageHeight)  .
											#rightOffset:.  (-100) .
											#bottomOffset:.  (imageHeight+50) .}}.
			#add:. {	{#model. #testGravatar }.
							#layout:. {#FrameLayout.
											#leftFraction:.  1 .
											#bottomFraction:.  0 .
											#leftOffset:.  (-100) .
											#topOffset:.  (imageHeight+25)  .
											#bottomOffset:.  (imageHeight+50) .}}.
							
			#add:. {	{#model. #editPublic }.
							#layout:. {#FrameLayout.
											#rightFraction:.  0.33 .
											#bottomFraction:.  0 .
											#topOffset:.  (50+imageHeight)  .
											#bottomOffset:.  (imageHeight+75) .}}.
			#add:. {	{#model. #editPrivate }.
							#layout:. {#FrameLayout.
											#leftFraction:.  0.33 .
											#rightFraction:.  0.66 .
											#bottomFraction:.  0 .
											#topOffset:.  (imageHeight+50)  .
											#bottomOffset:.  (imageHeight+75) .}}.
			#add:. {	{#model. #editPermissions }.
							#layout:. {#FrameLayout.
											#leftFraction:.  0.66 .
											#bottomFraction:.  0 .
											#topOffset:.  (imageHeight+50)  .
											#bottomOffset:.  (imageHeight+75) .}}}! !

!UserEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 16:54'!
avatar

	^ container! !

!UserEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/16/2012 15:55'!
editPermissions

	^ editPermissions! !

!UserEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 16:35'!
editPermissionsAction
	| usr editor |
	
	(usr := user contents) ifNil: [ ^ self ].
	usr unlock ifFalse: [ ^ self ].
	
	editor := PermissionsEditor new
				user: usr;
				openDialogWithSpec;
				yourself.
				
	self window openModal: editor window window.! !

!UserEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/12/2012 12:27'!
editPrivate

	^ editPrivate! !

!UserEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/2/2012 16:35'!
editPrivateAction

	user contents 
		ifNil: [ self ]
		ifNotNil: [:usr || editor kc |
			kc := usr keychain.
			kc unlock.
			editor := KeyChainViewer new
						keychain: kc;
						yourself.
			self window ifNotNil: [ self window openModal: editor openWithSpec window ]]! !

!UserEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/12/2012 12:27'!
editPublic

	^ editPublic! !

!UserEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/2/2012 16:35'!
editPublicAction

	user contents 
		ifNil: [ self ]
		ifNotNil: [:usr || editor |
			editor := KeyChainViewer new
						keychain: usr unlockedKeychain;
						yourself.
			self window ifNotNil: [ self window openModal: editor openWithSpec window ]]! !

!UserEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 16:54'!
gravatarAddress
	^ gravatarAddress! !

!UserEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 16:54'!
gravatarLabel
	^ gravatarLabel! !

!UserEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 8/2/2012 16:28'!
initialExtent

	^ 450@290! !

!UserEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 15:24'!
initialize
	"Initialization code for UserEditor"

	usersManager := nil asValueHolder.
	user := nil asValueHolder.
	
	super initialize.! !

!UserEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/9/2012 17:40'!
initializeContainer
	container := PanelMorph new
		height: 120;
		width: 120;
		changeProportionalLayout;
		vResizing: #rigid;
		hResizing: #rigid;
		yourself! !

!UserEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 17:15'!
initializeDialogWindow: aWindow

	aWindow okAction: [ self ok ]! !

!UserEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 16:05'!
initializePresenter 

	self registerGravatarAddressChanges.
	self registerUserNameChanges.	
	
	usersManager whenChangedDo: [:um | editPermissions enabled: (um currentUser canEditUser) ].
! !

!UserEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/9/2012 23:46'!
initializeSetPassword
	setPassword
		label: 'set password';
		state: false;
		enabled: false;
		action: [ self setNewPassword ]! !

!UserEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 10/25/2012 14:51'!
initializeUserName
	userName
		ghostText: 'username';
		entryCompletion: nil;
		autoAccept: true;
		enabled: false.! !

!UserEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 17:16'!
initializeWidgets
		
	self instantiateModels: #(
		gravatarAddress TextInputFieldModel
		setPassword ButtonModel
		testGravatar ButtonModel
		userName TextInputFieldModel
		editPublic ButtonModel
		editPrivate ButtonModel
		editPermissions ButtonModel ).
	
	self initializeContainer.
	self setGravatarAddress.
	self setTestGravatar.
	self registerUserChanges.
	self initializeSetPassword.
	self initializeUserName.
	
	editPublic
		label: 'edit public keychain';
		enabled: false;
		state: false;
		action: [ self editPublicAction ].
		
	editPrivate
		label: 'edit private keychain';
		enabled: false;
		state: false;
		action: [ self editPrivateAction ].
		
	editPermissions
		label: 'edit permissions';
		enabled: false;
		state: false;
		action: [ self editPermissionsAction ].
	
	self focusOrder 
		add: userName;
		add: setPassword;
		add: gravatarAddress;
		add: testGravatar;
		add: editPublic;
		add: editPrivate;
		add: editPermissions.! !

!UserEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/9/2012 17:07'!
isValidAddressMail: aString

	^ aString isEmpty not! !

!UserEditor methodsFor: 'private' stamp: 'EstebanLorenzano 12/6/2012 19:08'!
isValidUsername: aString

	^ (user contents username = aString or: [(self userNames includes: aString) not])! !

!UserEditor methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/11/2012 15:35'!
ok
	| pharoUser newName newAddress |
	
	(pharoUser := user contents) ifNil: [ ^ self ].

	newName := userName getText asString asSymbol.
	newAddress := gravatarAddress getText.
	pharoUser username = newName ifFalse: [ pharoUser username: newName ].
	(newAddress ~= originalEmail and: [ self isValidAddressMail: newAddress ])
		ifTrue: [ 
			pharoUser setUserName: newAddress forGroup: #gravatar.
			pharoUser updateGravatarFor: newAddress ].! !

!UserEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 15:42'!
registerGravatarAddressChanges
	gravatarAddress whenTextChanged: [ :text | testGravatar state: (self isValidAddressMail: text) ]! !

!UserEditor methodsFor: 'initialize' stamp: 'IgorStasenko 12/20/2012 14:37'!
registerUserChanges
	user
		whenChangedDo: [ :usr | 
			self window ifNotNil: [ :w | w title: self title ].
			gravatarAddress enabled: usr notNil.
			testGravatar enabled: usr notNil.
			userName enabled: usr notNil.
			setPassword enabled: usr notNil.
			editPermissions enabled: usr notNil.
			editPrivate enabled: usr notNil.
			editPublic enabled: usr notNil.
			usr
				ifNotNil: [ 
					userName text: user contents username.
					container removeAllMorphs.
					container addMorph: usr avatar copy fullFrame: LayoutFrame identity.
					originalEmail := usr userNameFor: #gravatar.
					originalEmail ifNotNil: [ gravatarAddress text: originalEmail ]]]! !

!UserEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 8/2/2012 17:17'!
registerUserNameChanges

	userName
		whenTextChanged: [ :text | 
			self window ifNotNil: [:w | w toolbar okButton enabled: (self isValidUsername: text)] .
			self setTitle: text ]! !

!UserEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 10/25/2012 14:50'!
setGravatarAddress

	gravatarAddress 
		ghostText: 'gravatar email address';
		entryCompletion: nil;
		autoAccept: true;
		enabled: false.! !

!UserEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/11/2012 18:00'!
setNewPassword
	| usr newPassword w |
	
	(usr := user contents) ifNil: [ ^ self ].
	usr unlock ifFalse: [ ^ self ].
	
	w := PasswordInitializationDialogWindow new.
	self window openModal: w.
	
	newPassword := w enteredValue.
	newPassword ifNil: [ ^ self ].
	usr setPassword: newPassword.! !

!UserEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 16:54'!
setPassword
	^ setPassword! !

!UserEditor methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 5/12/2012 12:31'!
setTestGravatar

	testGravatar
		label: 'test';
		state: false;
		action: [ self testGravatarAddress ];
		enabled: false.! !

!UserEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 22:09'!
setTitle: aString
	| string |
	
	string := (user contents isNil or: [ aString isNil ])
					ifTrue: [ 'Editing' ]
					ifFalse: [ 'Editing ', aString, '''s profile' ].
		
	self window
		ifNotNil: [:w | w title: string ]! !

!UserEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 16:54'!
testGravatar
	^ testGravatar! !

!UserEditor methodsFor: 'private' stamp: 'IgorStasenko 12/20/2012 14:37'!
testGravatarAddress
	| email newAvatar |
	email := gravatarAddress getText.
	newAvatar := [ user contents retrieveGravatarFromMail: email ]
						on: Error
						do: [ nil ].
	newAvatar
		ifNil:[ gravatarAddress morph flash ]
		ifNotNil: [ 
			container removeAllMorphs.
			container 
				addMorph: newAvatar 
				fullFrame: LayoutFrame identity].! !

!UserEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 21:06'!
title

	^ 'User editor'! !

!UserEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 16:54'!
user
	^ user! !

!UserEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/9/2012 17:25'!
user: anObject

	user contents: anObject! !

!UserEditor methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 17:02'!
userName
	^ userName! !

!UserEditor methodsFor: 'private' stamp: 'EstebanLorenzano 12/6/2012 19:08'!
userNames
	^UsersManager default userNames! !

!UserEditor methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/16/2012 16:08'!
usersManager: aUsersManager

	usersManager contents: aUsersManager! !
